import os
import pandas as pd
#from sklearn.model_selection import train_test_split 
from sklearn.linear_model import LinearRegression 

# Read and prepare input data ..........................................................................................
here_path = os.path.dirname(os.path.realpath(__file__))
data_file_name = 'data_pylie_forecast_contest_2019.csv'
data_file_path = os.path.join(here_path, data_file_name)

df = pd.read_csv(data_file_path)
data=pd.get_dummies(df)
# ......................................................................................................................

def fill(x):
    df1=data[data[x]>0]
    x1=df1[['precipitation','snow','temperature','daytype_R','daytype_U','daytype_W']]
    xt=df1[[x]]
    df2=data[data[x]<0]
    x2=df2[['precipitation','snow','temperature','daytype_R','daytype_U','daytype_W']]

    reg = LinearRegression() 
    x_train=x1
    y_train=xt
    x_test=x2
    reg.fit(x_train, y_train) 
    y_pred = reg.predict(x_test)
    m=-1
    for i in range(1277,1462):
            m=m+1
            df.at[i,x]=int(y_pred[m])


fill("fora")
fill("hora")
fill("ohia")

data5=pd.get_dummies(df)

data2=data5.loc[0:1095][['fora','fora','ohia','precipitation','snow','temperature','daytype_R','daytype_U','daytype_W']]
target=data5.loc[0:1095][['miya']]
data3=data5[data5['miya']<0][['fora','fora','ohia','precipitation','snow','temperature','daytype_R','daytype_U','daytype_W']]

reg = LinearRegression() 
x_train=data2
y_train=target
x_test=data3
reg.fit(x_train, y_train) 
y_pred = reg.predict(x_test)
m=-1
for i in range(1096,1462):
    m=m+1
    df.at[i,'miya']=int(y_pred[m])
           

# Your code here .......................................................................................................
my_pylie_id = 'first'  # replace with your own pylie profile id


# ......................................................................................................................


# Write solution data ..................................................................................................
solution_file_name = my_pylie_id + '_data_pylie_forecast_contest_2019.csv'
solution_file_path = os.path.join(here_path, solution_file_name)
df.to_csv(solution_file_path, index=False)
# ......................................................................................................................
